All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](http://semver.org/spec/v2.0.0.html).

## [UNRELEASED]
(nothing yet)

## [3.10.0] - 2023-06-03
### Changed
- lib: bumped some dependencies
- lib: added `noUncheckedIndexedAccess` to `tsconfig`
- lib: from now on tsconfig compilerOptions and package.json deps will be sorted with each upgrade

## [3.9.1] - 2023-04-14
### Fixed
- lib: `@knodes/typedoc-plugin-pages` invalid version after upgrading to 3.9.0
- lib: missing yarn for 3.9.0

## [3.9.0] - 2023-04-14
### Changed
- lib: dependencies bump
### Fixed
- self: small type issue in `updateContents` function

## [3.8.0] - 2023-02-19
### Added
- lib: git init when project has a repo defined
### Changed
- lib: husky is removed if not a repo
- lib: yarn install on initialize
### Fixed
- lib: prettier files copied into `template` folder when upgrading to 3.7.0
- self: `updatePath` could fail if used with async functions
### Dev
- self: added some docs to migration functions
- self: added a function to get migrator to perform manual tasks outside actual migration
- self: `setPath` is type-safer now

## [3.7.1] - 2023-02-09
### Fixed
- lib: breaking ability to import libraries because `types` added into `exports` in `3.7.0` as last property

## [3.7.0] - 2023-02-06
### Fixed
- `docs` script and `updates:*` scripts were outdated/missing if project was **created** with 3.6.0 version
### Changed
- lib: updated `typescript`
- `types` are added into `exports` list
### Added
- empty prettier install

## [3.6.0] - 2022-09-28
### Added
- lib: added `updates` scripts for easy checking what packages can be updated
- self: `safelyUpgradeDependency` function for easier version bumps
### Changed
- lib: updated a lot of libs
- lib: updated `docs` script

## [3.5.3] - 2022-09-26
### Changed
- lib: upgrade `ts-node`
- lib: upgrade `husky`
### Fixed
- lib: husky not installed properly

## [3.5.2] - 2022-08-21
### Fixed
- lib: newly created libraries had broken `docs` script since 3.5.0

## [3.5.1] - 2022-07-25
### Fixed
- self: missing `.pagesconfig` in npm package, preventing new lib from being created

## [3.5.0] - 2022-07-21
### Fixed
- lib: incorrect babel config file name in `.npmignore`
- lib: added `next-env` to `tsconfig`
### Changed
- lib: added `next-env` to `.npmignore`
- lib: added `pagesconfig.json` to `.npmignore`
- lib: added `.next` folder to npm & git ignore
- lib: added `demo` & `pages` folders to npm ignore for `esm` and `dist` folders
- lib: upgrade `eslint`
- lib: upgrade `nodemon`
- lib: upgrade `typedoc`
- lib: upgrade `typescript`
### Dev
- self: lint & deps upgrade
### Added
- lib: add eslint import plugin and rules

## [3.4.1] - 2022-02-13
### Fixed
- lib: audit issues - bump husky, jest, nodemon, typedoc
- self: audit issues - bump husky, jest, nodemon, typedoc

## [3.4.0] - 2021-09-18
### Added
- lib: eslint rules for React
### Changed
- lib: better support for React - using `next` for dev server instead of `parcel`

## [3.3.2] - 2021-08-18
### Changed
- lib: bump `eslint` & config

## [3.3.1] - 2021-07-04
### Changed
- lib: bumped `typedoc-plugin-pages-fork-fork` which fixes some bugs

## [3.3.0] - 2021-07-04
### Fixed
- lib: bug breaking `docs` script on 3.2.0 update
### Added
- self: migration update path based on prev value
- lib: `yarn audit` on prepublishOnly

## [3.2.0] - 2021-07-01
### Added
- lib: pages plugin for typedoc
- lib: `@types/jest`
### Changed
- lib: bump `@dzek69/eslint-config-typescript`, `jest`, `typedoc`
- self: migration copy without overwrite
- self: some typings improvements

## [3.1.1] - 2021-05-18
### Added
- lib: `start:dev:compatibility` restored, it is actually needed, even with `@types/`
- self: `husky` prepush hook
### Changed
- lib: bump `@dzek69/eslint-config-typescript`

## [3.1.0] - 2021-05-06
### Added
- self: React libraries creating support
- self: upgrading library to React type
### Changed
- lib: added `root: true` to eslint config file to prevent possible issues
### Removed
- lib: `start:dev:compatibility` as it is not needed, use `@types/` dir in your src instead
### Fixed
- self: library not working for creating new lib due to a missing file

## [3.0.3] - 2021-04-30
### Changed
- self: aggressive changes list should start with bullet point
- lib: tsconfig overwrite-update, set `lib` field because some build ins are unavailable without them
- lib: tsconfig update, uncommented everything, set all extra options to null
- lib: tsconfig `noUnusedLocals` & `noUnusedParameters` should be false in all files
- lib: tsconfig is now standard json to help with future safer updates
- lib: added `.eslintrc.json` to `.npmignore`
### Fixed
- lib: added missing `compile.cjs.after.mjs` code which fixes cjs output code use
- lib: added `babel-plugin-module-extension` dependency, which is required after updating one the deep deps

## [3.0.2] - 2021-04-14
### Changed
- updated typedoc and typescript

## [3.0.1] - 2021-02-26
### Changed
- updated eslint config
### Fixed
- build script failing

## [3.0.0] - 2021-02-19
### Added
- migrations support
- linting
- docs
### Fixed
- esm code output

## [0.0.2-beta.5 and earlier] - 2021-02-19
### Added
- first version
- migrations support
